%Codes to Replicate - The Deflationary Bias of the ZLB and the FED's Strategic Response
%Figures 8a
%by Adrian Penalver and Daniele Siena
%JMCB January 2024

clear all
close all
clc

% Set common parameters
u = 1.5303;
l = -u;
sca = 201;
grid = linspace(l,u,sca);
u_2 = 1.5/1.2;
l_2 = -u_2;
sca = 201;
grid_2 = linspace(l_2,u_2,sca);
un = 5; 
b = 0.2;
pistar = 2;
p1 = pistar;
rstar = 0;
zer = zeros(1,sca);
pi_bitd = zeros(1,sca);
obs = linspace(1,sca,sca);
%%
% model parameters
a = 1.2;

b = 0.2;
pistar = 2;
p1 = pistar;
rstar = 0;

% grids
r0 = rstar;

II = '$i$';
R = '$r^{\ast} = $';
PI = '$\pi$';
EPI = '$E(\pi)$';
PIS = '$\pi^{\ast} =$';
IT = '- IT';
DM = '- DM';
U = '$(U - U^{*})$ - Unemployment gap';

d = grid;

%%
new = 0;
if new == 1
% Testing what x should be to reach the inflation target of 2% in presence
% of the disinflation bias


T=250; 
P=1000;
pistar = 2;
count_rstar = 0; 
pick = 0.15:0.025:1;
size_pick = size(pick,2);
Results = zeros(size(pick,2),3);
%x_raw = zeros(size_pick,1);
%x_raw = [4.8 3 2.4 1.7 1.3 1 0.85 0.55 0.45 0.35 0.33];
%x_raw = [29.01 9.32 4.83 3.01 2.41 1.71 1.31 1.01 0.85 0.57 0.46 0.38 0.34 0.27 0.24 0.18 0.15 0.14];
%x_raw = [29.01 19.165 9.32 7.075 4.83 3.92 3.01 2.71 2.41 2.06 1.71 1.51 1.31 1.16 1.01 0.93 0.85 0.71 0.57 0.515 0.46 0.42 0.38 0.36 0.34 0.305 0.27 0.255 0.24 0.21 0.18 0.1665 0.15 0.145 0.14];
x_raw = [4.98500000000000;4.04500000000000;3.11500000000000;2.71000000000000;2.36500000000000;2.03500000000000;1.69500000000000;1.48500000000000;1.31000000000000;1.19000000000000;1.04500000000000;0.905000000000000;0.815000000000000;0.735000000000000;0.615000000000000;0.550000000000000;0.500000000000000;0.455000000000000;0.415000000000000;0.390000000000000;0.360000000000000;0.325000000000000;0.290000000000000;0.255000000000000;0.230000000000000;0.210000000000000;0.200000000000000;0.186500000000000;0.170000000000000;0.140000000000000;0.130000000000000];
%for i=1:size(x_raw,2)-1
%    medium(i) = 0.5*(x_raw(i)+x_raw(i+1));
%end

for i  = 1:size_pick
    rstar = pick(i)
    count_rstar = count_rstar + 1;
    x = x_raw(i);
r1 = rstar;
avepi1_round=0;
lambda = 0.5;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);
pistart = zeros(T,P);
pistart(1,:) = pistar;
%dt      = u*(rand(T-1,P)-0.5);
rng('default')
rng(1);
dt = unifrnd(l,u,T-1,P);
iut     = zeros(T-1,P);
pit     = zeros(T-1,P);
avepi1   = zeros(T-1,P);
%avepi2   = zeros(T-1,P);
count = 1;
count_max = 1000;
while abs(avepi1_round - 2) > 0.005 && (count < count_max)
count = count + 1;
if avepi1_round > 2 
x = x - 0.005;
else 
x = x + 0.005;
end
for p = 1:P
for t = 1:T-1

    %dt(t) = l + (u-l)*(rand-0.5);
    iut(t,p) = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistart(t,p))/(b*(lambda+a^2))+dt(t,p);
    if iut(t,p)>0
        pit(t,p) = (lambda*epi+pistart(t)*a^2)/(lambda+a^2);
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar + a*dt(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = pistar + (pistar - pit(t,p)) + x*pistar;
    else
       pistart(t+1,p) = pistar;
    end
    avepi1(t,p) = mean(pit(1:t,p));

end
end

avepi1_round = mean(mean(pit(T-1,:)));


per1=10;
per2=90;

Per10a = prctile(avepi1,per1,2);
Per90a = prctile(avepi1,per2,2);

%meanpi = mean(avepi1(T-1))
meanpi = mean(mean(pit(T-1,:)));
end
Results(count_rstar,:)=[rstar,x,meanpi];

end


save('Loop_results','Results')
elseif new==0
    load('Loop_results')
end

%% Figure of the Loop results

figure19 = figure;
axes19 = axes('Parent',figure19);
h1 = plot(Results(:,1), Results(:,2));
hold on
h2 = line([0,1],[1,1]);
hold off
xlabel('r^{\ast} - natural rate','fontsize',16)
ylabel('\gamma - gamma','fontsize',16)
set(h1,'Color',[1,0,0],'LineStyle','-','DisplayName','Bomba','LineWidth',2);
set(h2,'Color',[0,0,1],'LineStyle','--','LineWidth',1);
%legend19 = legend([h1,h2,h4]);
%set(legend10,'Location','northwest','FontSize',18,'box','off');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
%L0 = min(wel_comparison_d_d(:,5));
%L1 = max(wel_comparison_d_d(:,5));
%L2 = get(gca,'YLim');
axis([0.13,1,0,30])
% Latex Name
%fn = 'Figure_FAIT_flexible';
% Paper Name
fn = 'Figure8_a';

set(gca,'fontsize',16) 
fig=gcf;
fig.Position(3:4)=[500,550];
print( gcf, '-dpdf', fn )
