%Codes to Replicate - The Deflationary Bias of the ZLB and the FED's Strategic Response
%Figures 8b
%by Adrian Penalver and Daniele Siena
%JMCB January 2024

clear all
close all
clc

% grid size
u = 1.5;
l = -u;
sca = 201;
grid_2 = linspace(l,u,sca);
d = grid_2;
s1 = 0;
s = grid_2;
% structural parameters
a = 1/(1.2);
b = 0.2;

% Policy and welfare preference
lambda = 0.5;
phi = 0.5;

% Pistar and rstar
pistar = 2;
p1 = pistar;
rstar = 0;
r0 = rstar;

% preset space
zer = zeros(1,sca);
pi_bitd = zeros(1,sca);
obs = linspace(1,sca,sca);

% Names 
II = '$i$';
R = '$r^{\ast} = $';
PI = '$\pi$';
EPI = '$E(\pi)$';
PIS = '$\pi^{\ast} =$';
IT = '- IT';
DM = '- DM';

% Set of structural parameters
bb  = 0.1:0.01:0.95;
j_end = size(bb,2); 
aa = 0.1:0.01:0.95;
i_end = size(aa,2);
wel_dualmandate_d_ab_grid = zeros(i_end,3,j_end);
wel_dualmandate_s_ab_grid = zeros(i_end,3,j_end);
uu = 0.5:0.2:6;
u_end = size(uu,2);

wel_dualmandate_d_d = zeros(u_end,1);
wel_dualmandate_d_pc = zeros(u_end,1);
wel_dualmandate_d_is = zeros(u_end,1);
wel_dualmandate_d_st = zeros(u_end,1);
wel_dualmandate_d_rs = zeros(u_end,1);
wel_dualmandate_d_la = zeros(u_end,1);

wel_dualmandate_s_s = zeros(u_end,1);
wel_dualmandate_s_pc = zeros(u_end,1);
wel_dualmandate_s_is = zeros(u_end,1);

% Type of analysis 
analysis = 2;
% 1 = a, b
% 3 = grid


%% Analysis checking a grid of IS and PC slopes
if analysis == 1
    for jj = 1:j_end
    b = bb(jj);
for ii = 1:i_end
    a = aa(ii);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
root = 1;
A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmd = max(I);
inde = find(i_bdmd);
[K,invind] = setdiff(obs,inde);
pi_bdmd(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmd(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
prob_nzlb_bdmd = size(inde,2)/size(d,2);
epi_bdmd = ones(1,size(d,2))*epi;
prob_hit = (size(i_bdmd,2)-size(inde,2))/size(i_bdmd,2);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Supply - baseline (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
zer = zeros(1,sca);
s = grid_2;
root = 2;
A = -0.5;
B = (b * (a^2*lambda + 1) * u + a*l ) / (a + b * (a^2*lambda+1) );
X = - (l * pistar)/(a^2*lambda + 1) + ( a * lambda * l^2) / ( 2 * (a^2*lambda + 1)) + (b * u * rstar) / a - (u^2) / (2 * a);
Y = ( b * (a^2*lambda + 1) * u + a * l ) * ( (a * pistar ) / ( a + b * (a^2*lambda + 1)) - (b * (a^2*lambda + 1) * rstar) / ( a + b * (a^2*lambda + 1)));
C = Y + a * (a^2*lambda + 1) * X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = s_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar - s); 
I  = [iu;zer];
i_bdms = max(I);
inde = find(i_bdms);
[K,invind] = setdiff(obs,inde);
pi_bdms(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar - a * lambda .* s(inde));
pi_bdms(invind) = 1 / a * ( (a + b) * epi + b * rstar - s(invind));
prob_nzlb_bdms = size(inde,2)/size(s,2);
epi_bdms = ones(1,size(d,2))*epi;
root = 1;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Welfare computationaa
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if isreal(pi_bdmd)
    wel_dualmandate_d_ab_grid(ii,1,jj) = welfare_function_2(phi,a,pi_bdmd,pistar,s1,epi_bdmd);
    wel_dualmandate_d_ab_grid(ii,2,jj) = a;
    wel_dualmandate_d_ab_grid(ii,3,jj) = b;    
end

if isreal(pi_bdms)
    wel_dualmandate_s_ab_grid(ii,1,jj) = welfare_function_2(phi,a,pi_bdms,pistar,s,epi_bdms);
    wel_dualmandate_s_ab_grid(ii,2,jj) = a;
    wel_dualmandate_s_ab_grid(ii,3,jj) = b;    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - demand
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmd  = max(I);
inde = find(i_shdmd);
[K,invind] = setdiff(obs,inde);
pi_shdmd(inde) = pistar + a * lambda;
pi_shdmd(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
prob_nzlb_shdmd = size(inde,2)/size(d,2);
epi_shdmd = ones(1,size(d,2))*epi;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - supply
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
zer = zeros(1,sca);
root = 2;

A = -0.5;
B = (b*u+a*l)/(a+b);
X = -(a*lambda + pistar)*l+(b*rstar*u)/a - (u^2)/(2*a);
Y = (b*u + a*l) * ((a^2*lambda - b * rstar + a * pistar)/(a + b)); 
C = Y + a*X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = (a^2*lambda - b*rstar + a * pistar)/(a+b) + 1/(a + b) * s_bar;

iu = rstar + 1/b * ((a+b)*epi - a^2*lambda - a*pistar) - 1/b * s;
I  = [iu;zer];
i_shdms  = max(I);
inde = find(i_shdms);
[K,invind] = setdiff(obs,inde);
pi_shdms(inde) = pistar + a * lambda;
pi_shdms(invind) = (a + b)/ a * epi - 1/a .*s(invind) + (b * rstar) / a;
prob_nzlb_shdms = size(inde,2)/size(s,2);
epi_shdms = ones(1,size(d,2))*epi;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Welfare computation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if isreal(epi_shdmd)
    wel_shortfall_d_a(ii,1,jj) = welfare_function_2(phi,a,pi_shdmd,pistar,s1,epi_shdmd);
    wel_shortfall_d_a(ii,2,jj) = a;
    wel_shortfall_a(ii,3,jj) = b;
end

if isreal(epi_shdms)
    wel_shortfall_s_a(ii,1,jj) = welfare_function_2(phi,a,pi_shdms,pistar,s,epi_shdms);
    wel_shortfall_s_a(ii,2,jj) = a;
    wel_shortfall_s(ii,3,jj) = b;
end


% Welfare comparison

if isreal(pi_bdmd) && isreal(pi_shdmd)
    wel_comparison_d_a(ii,1,jj) = wel_dualmandate_d_ab_grid(ii,1,jj) - wel_shortfall_d_a(ii,1,jj);
end


end
    end
figure(1)
surf(aa', bb,squeeze(wel_dualmandate_d_ab_grid(:,1,:))');
figure(2)
surf(aa', bb,squeeze(wel_shortfall_d_a(:,1,:))');
figure(3)
surf(aa', bb,squeeze(wel_comparison_d_a(:,1,:))');
figure (4)
plot(aa,wel_comparison_d_a(:,1,1));
figure (5)
plot(bb,squeeze(wel_comparison_d_a(1,1,:)));
end

%% Analysis checking for different variance of shocks (probability of ZLB)

if analysis == 2% structural parameters
  a = 1/(1.2);
  b = 0.2;

for kk = 1:u_end
     u = uu(kk);
     l = -u;
     sca = 201;
     grid_2 = linspace(l,u,sca);
     d = grid_2;
     s = grid_2;
     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. Demand - baseline (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
root = 1;
A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmd = max(I);
inde = find(i_bdmd);
[K,invind] = setdiff(obs,inde);
pi_bdmd(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmd(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
prob_nzlb_bdmd = size(inde,2)/size(d,2);
epi_bdmd = ones(1,size(d,2))*epi;
epi_diff_d_dm =  epi_bdmd - pistar;
pi_diff_d = pi_bdmd - epi_bdmd;
prob_hit_d = (size(i_bdmd,2)-size(inde,2))/size(i_bdmd,2);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Demand - baseline (dual mandate)low PC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a = 1/0.8;
rstar = 0;
lambda = 0.5;
root = 1;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmdpc = max(I);
inde = find(i_bdmdpc);
[K,invind] = setdiff(obs,inde);
pi_bdmdpc(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmdpc(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bdmdpc = ones(1,size(d,2))*epi;

epi_diff_d_dm_pc =  epi_bdmdpc - pistar;
pi_diff_d_pc = pi_bdmdpc - epi_bdmdpc;
prob_hit_d_pc = (size(i_bdmdpc,2)-size(inde,2))/size(i_bdmdpc,2);

a = 1/1.2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3. Demand - baseline (dual mandate) low IS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pistar = 2; 
rstar = 0;
lambda = 0.5;
root = 1;
b = 0.15;
a = 1/1.2;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmdis = max(I);
inde = find(i_bdmdis);
[K,invind] = setdiff(obs,inde);
pi_bdmdis(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmdis(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bdmdis = ones(1,size(d,2))*epi;

epi_diff_d_dm_is =  epi_bdmdis - pistar;
pi_diff_d_is = pi_bdmdis - epi_bdmdis;
prob_hit_d_is = (size(i_bdmdis,2)-size(inde,2))/size(i_bdmdis,2);

b = 0.2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4. Demand - higher pistar (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0.5;
pistar = 3;
root = 1;
a = 1/(1.2);
p2 = pistar;
b = 0.2;
rstar = 0;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_stdmd = max(I);
inde = find(i_stdmd);
[K,invind] = setdiff(obs,inde);
pi_stdmd(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_stdmd(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_stdmd = ones(1,size(d,2))*epi;

epi_diff_d_dm_st =  epi_stdmd - pistar;
pi_diff_d_st = pi_stdmd - epi_stdmd;
prob_hit_d_st = (size(i_stdmd,2)-size(inde,2))/size(i_stdmd,2);

pistar = 2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 5. Demand - baseline (dual mandate) - higher rstar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pistar = 2; 
rstar = 1;
lambda = 0.5;
root = 1;
b = 0.2;
a = 1/1.2;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmdrs = max(I);
inde = find(i_bdmdrs);
[K,invind] = setdiff(obs,inde);
pi_bdmdrs(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmdrs(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bdmdrs = ones(1,size(d,2))*epi;

epi_diff_d_dm_rs =  epi_bdmdrs - pistar;
pi_diff_d_rs = pi_bdmdrs - epi_bdmdrs;
prob_hit_d_rs = (size(i_bdmdrs,2)-size(inde,2))/size(i_bdmdrs,2);

rstar = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 6. Demand - baseline (dual mandate) - higher lambda
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pistar = 2; 
rstar = 0;
lambda = 0.9;
root = 1;
b = 0.2;
a = 1/1.2;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmdla = max(I);
inde = find(i_bdmdrs);
[K,invind] = setdiff(obs,inde);
pi_bdmdla(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmdla(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bdmdla = ones(1,size(d,2))*epi;

epi_diff_d_dm_la =  epi_bdmdla - pistar;
pi_diff_d_la = pi_bdmdla - epi_bdmdla;
prob_hit_d_la = (size(i_bdmdla,2)-size(inde,2))/size(i_bdmdla,2);

lambda = 0.5;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Supply - baseline (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
zer = zeros(1,sca);
root = 2; 
A = -0.5;
B = (b * (a^2*lambda + 1) * u + a*l ) / (a + b * (a^2*lambda+1) );
X = - (l * pistar)/(a^2*lambda + 1) + ( a * lambda * l^2) / ( 2 * (a^2*lambda + 1)) + (b * u * rstar) / a - (u^2) / (2 * a);
Y = ( b * (a^2*lambda + 1) * u + a * l ) * ( (a * pistar ) / ( a + b * (a^2*lambda + 1)) - (b * (a^2*lambda + 1) * rstar) / ( a + b * (a^2*lambda + 1)));
C = Y + a * (a^2*lambda + 1) * X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = s_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar - s); 
I  = [iu;zer];
i_bdms = max(I);
inde = find(i_bdms);
[K,invind] = setdiff(obs,inde);
pi_bdms(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar - a * lambda .* s(inde));
pi_bdms(invind) = 1 / a * ( (a + b) * epi + b * rstar - s(invind));
prob_nzlb_bdms = size(inde,2)/size(s,2);
epi_bdms = ones(1,size(d,2))*epi;
epi_diff_s_dm =  epi_bdms - pistar;
pi_diff_s = pi_bdms - epi_bdms;
prob_hit_s = (size(i_bdms,2)-size(inde,2))/size(i_bdms,2);
root = 1; 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%1. Shortfalls - demand
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmd  = max(I);
inde = find(i_shdmd);
[K,invind] = setdiff(obs,inde);
pi_shdmd(inde) = pistar + a * lambda;
pi_shdmd(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
prob_nzlb_shdmd = size(inde,2)/size(d,2);
epi_shdmd = ones(1,size(d,2))*epi;
epi_diff_d_sf =  epi_shdmd - pistar;
epi_diff_d = epi_shdmd - epi_bdmd;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%2. Shortfalls - demand - steep PC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lambda = 0.5;
a = 1/0.8;
root = 1; 
b = 0.2;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdpc  = max(I);
inde = find(i_shdmdpc);
[K,invind] = setdiff(obs,inde);
pi_shdmdpc(inde) = pistar + a * lambda;
pi_shdmdpc(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
prob_nzlb_shdmdpc = size(inde,2)/size(d,2);
epi_shdmdpc = ones(1,size(d,2))*epi;

epi_diff_d_sf_pc =  epi_shdmdpc - pistar;
epi_diff_d_pc = epi_shdmdpc - epi_bdmdpc;

a = 1/1.2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%3. Shortfalls - demand - steeper IS 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lambda = 0.5;
a = 1/1.2;
root = 1; 
b = 0.15;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);


iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdis  = max(I);
inde = find(i_shdmdis);
[K,invind] = setdiff(obs,inde);
pi_shdmdis(inde) = pistar + a * lambda;
pi_shdmdis(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
epi_shdmdis = ones(1,size(d,2))*epi;

epi_diff_d_sf_is =  epi_shdmdis - pistar;
epi_diff_d_is = epi_shdmdis - epi_bdmdis;

b = 0.2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%4. Shortfalls - demand - high pistar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pistar = 3;
lambda = 0.5;
a = 1/1.2;
root = 1; 
b = 0.2;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdst  = max(I);
inde = find(i_shdmdis);
[K,invind] = setdiff(obs,inde);
pi_shdmdst(inde) = pistar + a * lambda;
pi_shdmdst(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
epi_shdmdst = ones(1,size(d,2))*epi;

epi_diff_d_sf_st =  epi_shdmdst - pistar;
epi_diff_d_st = epi_shdmdst - epi_stdmd;

pistar = 2; 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%5. Shortfalls - demand - higher rstar 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

rstar = 1;
lambda = 0.5;
a = 1/1.2;
root = 1; 
b = 0.2;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);


iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdrs  = max(I);
inde = find(i_shdmdis);
[K,invind] = setdiff(obs,inde);
pi_shdmdrs(inde) = pistar + a * lambda;
pi_shdmdrs(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
epi_shdmdrs = ones(1,size(d,2))*epi;

epi_diff_d_sf_rs =  epi_shdmdrs - pistar;
epi_diff_d_rs = epi_shdmdrs - epi_bdmdrs;

rstar = 0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%6. Shortfalls - demand - higher lambda
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lambda = 0.9;
a = 1/1.2;
root = 1; 
b = 0.2;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end


epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);


iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdla  = max(I);
inde = find(i_shdmdis);
[K,invind] = setdiff(obs,inde);
pi_shdmdla(inde) = pistar + a * lambda;
pi_shdmdla(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
epi_shdmdla = ones(1,size(d,2))*epi;

epi_diff_d_sf_la =  epi_shdmdla - pistar;
epi_diff_d_la = epi_shdmdla - epi_bdmdla;

lambda = 0.5;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - supply
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
root = 2;

A = -0.5;
B = (b*u+a*l)/(a+b);
X = -(a*lambda + pistar)*l+(b*rstar*u)/a - (u^2)/(2*a);
Y = (b*u + a*l) * ((a^2*lambda - b * rstar + a * pistar)/(a + b)); 
C = Y + a*X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = (a^2*lambda - b*rstar + a * pistar)/(a+b) + 1/(a + b) * s_bar;

iu = rstar + 1/b * ((a+b)*epi - a^2*lambda - a*pistar) - 1/b * s;
I  = [iu;zer];
i_shdms  = max(I);
inde = find(i_shdms);
[K,invind] = setdiff(obs,inde);
pi_shdms(inde) = pistar + a * lambda;
pi_shdms(invind) = (a + b)/ a * epi - 1/a .*s(invind) + (b * rstar) / a;
prob_nzlb_shdms = size(inde,2)/size(s,2);
epi_shdms = ones(1,size(d,2))*epi;
epi_diff_s_sf =  epi_shdms - pistar;
epi_diff_s = epi_shdms - epi_bdms;
%epi_diff_s = epi_bdms - epi_shdms;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Welfare computation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Dual Mandate

if isreal(epi_bdmd)
    wel_dualmandate_d_d(kk,1) = welfare_function_2(phi,a,pi_bdmd,pistar,s1,epi_bdmd);
    wel_dualmandate_d_d(kk,2) = uu(kk);
end
if isreal(epi_bdmdpc)
    wel_dualmandate_d_pc(kk,1) = welfare_function_2(phi,1/0.8,pi_bdmdpc,pistar,s1,epi_bdmdpc);
    wel_dualmandate_d_pc(kk,2) = uu(kk);
end
if isreal(epi_bdmdis)
    wel_dualmandate_d_is(kk,1) = welfare_function_2(phi,a,pi_bdmdis,pistar,s1,epi_bdmdis);
    wel_dualmandate_d_is(kk,2) = uu(kk);    
end
if isreal(epi_stdmd)
    wel_dualmandate_d_st(kk,1) = welfare_function_2(phi,a,pi_stdmd,3,s1,epi_stdmd);
    wel_dualmandate_d_st(kk,2) = uu(kk);
end
if isreal(epi_bdmdrs)
    wel_dualmandate_d_rs(kk,1) = welfare_function_2(phi,a,pi_bdmdrs,pistar,s1,epi_bdmdrs);
    wel_dualmandate_d_rs(kk,2) = uu(kk);    
end
if isreal(epi_bdmdla)    
    wel_dualmandate_d_la(kk,1) = welfare_function_2(phi,a,pi_bdmdla,pistar,s1,epi_bdmdla);
    wel_dualmandate_d_la(kk,2) = uu(kk);    
end


if isreal(epi_bdms)
    wel_dualmandate_s_s(kk,1) = welfare_function_2(phi,a,pi_bdms,pistar,s,epi_bdms);
    wel_dualmandate_s_s(kk,2) = uu(kk);
end

if isreal(epi_shdmd)
    wel_shortfall_d_d(kk,1) = welfare_function_2(phi,a,pi_shdmd,pistar,s1,epi_shdmd);
    wel_shortfall_d_d(kk,2) = uu(kk);
end
if isreal(epi_shdmdpc)
    wel_shortfall_d_pc(kk,1) = welfare_function_2(phi,1/0.8,pi_shdmdpc,pistar,s1,epi_shdmdpc);
    wel_shortfall_d_pc(kk,2) = uu(kk);
end
if isreal(epi_shdmdis)   
    wel_shortfall_d_is(kk,1) = welfare_function_2(phi,a,pi_shdmdis,pistar,s1,epi_shdmdis);
    wel_shortfall_d_is(kk,2) = uu(kk);    
end
if isreal(epi_shdmdst)  
    wel_shortfall_d_st(kk,1) = welfare_function_2(phi,a,pi_shdmdst,3,s1,epi_shdmdst);
    wel_shortfall_d_st(kk,2) = uu(kk);
end
if isreal(epi_shdmdrs)    
    wel_shortfall_d_rs(kk,1) = welfare_function_2(phi,a,pi_shdmdrs,pistar,s1,epi_shdmdrs);
    wel_shortfall_d_rs(kk,2) = uu(kk); 
end
if isreal(epi_shdmdla)    
    wel_shortfall_d_la(kk,1) = welfare_function_2(phi,a,pi_shdmdla,pistar,s1,epi_shdmdla);
    wel_shortfall_d_la(kk,2) = uu(kk);        
end

if isreal(epi_shdms)
    wel_shortfall_s_s(kk,1) = welfare_function_2(phi,a,pi_shdms,pistar,s,epi_shdms);
    wel_shortfall_s_s(kk,2) = uu(kk);
end

% Welfare comparison

if isreal(pi_bdmd) && isreal(pi_shdmd)
    wel_comparison_d_d(kk,1) = wel_dualmandate_d_d(kk,1) - wel_shortfall_d_d(kk,1);
    wel_comparison_d_d(kk,2) = u;
    wel_comparison_d_d(kk,3) = epi_diff_d_dm(1,1);
    wel_comparison_d_d(kk,4) = pi_diff_d(1,1);  
    wel_comparison_d_d(kk,5) = prob_hit_d; 
    wel_comparison_d_d(kk,6) = 1/12 * (u-l)^2;
    wel_comparison_d_d(kk,7) = epi_diff_d_sf(1,1);
    wel_comparison_d_d(kk,8) = epi_diff_d(1,1);
end

if isreal(epi_bdmdpc) && isreal(epi_shdmdpc)
    wel_comparison_d_pc(kk,1) = wel_dualmandate_d_pc(kk,1) - wel_shortfall_d_pc(kk,1);
    wel_comparison_d_pc(kk,2) = u;
    wel_comparison_d_pc(kk,3) = epi_diff_d_dm_pc(1,1);
    wel_comparison_d_pc(kk,4) = pi_diff_d_pc(1,1);  
    wel_comparison_d_pc(kk,5) = prob_hit_d_pc; 
    wel_comparison_d_pc(kk,6) = 1/12 * (u-l)^2;
    wel_comparison_d_pc(kk,7) = epi_diff_d_sf_pc(1,1);
    wel_comparison_d_pc(kk,8) = epi_diff_d_pc(1,1);
end


if isreal(epi_bdmdis) && isreal(epi_shdmdis)
    wel_comparison_d_is(kk,1) = wel_dualmandate_d_is(kk,1) - wel_shortfall_d_is(kk,1);
    wel_comparison_d_is(kk,2) = u;
    wel_comparison_d_is(kk,3) = epi_diff_d_dm_is(1,1);
    wel_comparison_d_is(kk,4) = pi_diff_d_is(1,1);  
    wel_comparison_d_is(kk,5) = prob_hit_d_is; 
    wel_comparison_d_is(kk,6) = 1/12 * (u-l)^2;
    wel_comparison_d_is(kk,7) = epi_diff_d_sf_is(1,1);
    wel_comparison_d_is(kk,8) = epi_diff_d_is(1,1);
end

if isreal(epi_stdmd) && isreal(epi_shdmdst)
    wel_comparison_d_st(kk,1) = wel_dualmandate_d_st(kk,1) - wel_shortfall_d_st(kk,1);
    wel_comparison_d_st(kk,2) = u;
    wel_comparison_d_st(kk,3) = epi_diff_d_dm_st(1,1);
    wel_comparison_d_st(kk,4) = pi_diff_d_st(1,1);  
    wel_comparison_d_st(kk,5) = prob_hit_d_st; 
    wel_comparison_d_st(kk,6) = 1/12 * (u-l)^2;
    wel_comparison_d_st(kk,7) = epi_diff_d_sf_st(1,1);
    wel_comparison_d_st(kk,8) = epi_diff_d_st(1,1);
end

if isreal(epi_bdmdrs) && isreal(epi_shdmdrs)
    wel_comparison_d_rs(kk,1) = wel_dualmandate_d_rs(kk,1) - wel_shortfall_d_rs(kk,1);
    wel_comparison_d_rs(kk,2) = u;
    wel_comparison_d_rs(kk,3) = epi_diff_d_dm_rs(1,1);
    wel_comparison_d_rs(kk,4) = pi_diff_d_rs(1,1);  
    wel_comparison_d_rs(kk,5) = prob_hit_d_rs; 
    wel_comparison_d_rs(kk,6) = 1/12 * (u-l)^2;
    wel_comparison_d_rs(kk,7) = epi_diff_d_sf_rs(1,1);
    wel_comparison_d_rs(kk,8) = epi_diff_d_rs(1,1);
end

if isreal(epi_bdmdla) && isreal(epi_shdmdla)
    wel_comparison_d_la(kk,1) = wel_dualmandate_d_la(kk,1) - wel_shortfall_d_la(kk,1);
    wel_comparison_d_la(kk,2) = u;
    wel_comparison_d_la(kk,3) = epi_diff_d_dm_la(1,1);
    wel_comparison_d_la(kk,4) = pi_diff_d_la(1,1);  
    wel_comparison_d_la(kk,5) = prob_hit_d_la; 
    wel_comparison_d_la(kk,6) = 1/12 * (u-l)^2;
    wel_comparison_d_la(kk,7) = epi_diff_d_sf_la(1,1);
    wel_comparison_d_la(kk,8) = epi_diff_d_la(1,1);
end

if isreal(pi_bdms) && isreal(epi_shdms)
    wel_comparison_s_s(kk,1) = wel_dualmandate_s_s(kk,1) - wel_shortfall_s_s(kk,1);
    wel_comparison_s_s(kk,2) = u;
    wel_comparison_s_s(kk,3) = epi_diff_s_dm(1,1);
    wel_comparison_s_s(kk,4) = pi_diff_s(1,1);  
    wel_comparison_s_s(kk,5) = prob_hit_s; 
    wel_comparison_s_s(kk,6) = 1/12 * (u-l)^2;
    wel_comparison_s_s(kk,7) = epi_diff_s_sf(1,1);
    wel_comparison_s_s(kk,8) = epi_diff_s(1,1);
end

eps = 10^-3 ;
idx_d = abs(wel_comparison_d_d(:,1))<=eps ;
turn_point_d = find(idx_d~=0);
turn_point_val =wel_comparison_d_d(turn_point_d,:); 

eps = 10^-3 ;
idx_s = abs(wel_comparison_s_s(:,1))<=eps ;
turn_point_s = find(idx_s~=0);
turn_point_val =wel_comparison_s_s(turn_point_s,:); 

end

%% Figures

figure30 = figure;
axes30 = axes('Parent',figure30);
h1 = plot(wel_comparison_d_d(:,5), wel_comparison_d_d(:,1));
hold on
h5 = plot(wel_comparison_d_pc(:,5), wel_comparison_d_pc(:,1));
hold on
h6 = plot(wel_comparison_d_is(:,5), wel_comparison_d_is(:,1));
hold on
%h7 = plot(wel_comparison_d_la(:,5), wel_comparison_d_la(:,1));
%hold on
h8 = plot(wel_comparison_d_st(:,5), wel_comparison_d_st(:,1));
hold on
h3 = plot(wel_comparison_d_d(:,5),zeros(size(wel_comparison_d_d(:,2),1),1));
hold off;
xlabel('Probability of hitting the ZLB')
ylabel('Welfare Gain from switching to SF')
set(h1,'Color',[1,0,0],'LineStyle','--','DisplayName','Baseline','LineWidth',3);
set(h5,'Color',[0,0,1],'LineStyle',':','DisplayName','Flatter PC','LineWidth',3);
set(h6,'Color',[0,1,0],'LineStyle','-.','DisplayName','Steeper IS','LineWidth',3);
%set(h7,'Color',[0,0.5,0],'LineStyle','-.','DisplayName','Higher \lambda','LineWidth',2);
set(h8,'Color',[1,0.5,0],'LineStyle','-.','Marker','o','DisplayName','Higher \pi^*','LineWidth',2);
set(h3,'Color',[0,0,0],'LineStyle','-','LineWidth',1);
legend30 = legend([h1,h5,h6,h8]);
set(legend30,'Location','northwest','FontSize',18,'box','off');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
L0 = min(wel_comparison_d_d(:,5));
L1 = 0.55;
L2 = get(gca,'YLim');
axis([L0,0.55,L2(1),0.1])
% Name Latex
%fn = 'Figure_WelGain_d_all';
% Name Paper
fn = 'Figure8_b';

set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )

end

 
