%Codes to Replicate - The Deflationary Bias of the ZLB and the FED's Strategic Response
%Figures 1-5
%by Adrian Penalver and Daniele Siena
%JMCB January 2024

clear all
close all
clc

version = 2; 

% if no_plot = 1 then it does not do the figures;
no_plot = 0;

% Set common parameters
u = 1.5;
l = -u;
sca = 201;
grid = linspace(l,u,sca);
u_2 = 1.5/1.2;
l_2 = -u_2;
sca = 201;
grid_2 = linspace(l_2,u_2,sca);
un = 5; 
b = 0.2;
pistar = 2;
p1 = pistar;
rstar = 0;
zer = zeros(1,sca);
pi_bitd = zeros(1,sca);
obs = linspace(1,sca,sca);
% model parameters
if version == 1
a = 1.2;
elseif version == 2
a = 1/(1.2);
end

b = 0.2;
pistar = 2;
p1 = pistar;
rstar = 0;

% grids
r0 = rstar;

II = '$i$';
R = '$r^{\ast} = $';
PI = '$\pi$';
EPI = '$E(\pi)$';
PIS = '$\pi^{\ast} =$';
IT = '- IT';
DM = '- DM';
U = '$(U - U^{*})$ - Unemployment gap';

d = grid;

%%
if version == 2
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (inflation targeter)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pistar = 2;
lambda = 0;
root = 1;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bitd = max(I);
inde = find(i_bitd);
[K,invind] = setdiff(obs,inde);
pi_bitd(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bitd(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bitd = ones(1,size(d,2))*epi;
u_bitd = un +  b * (i_bitd - epi_bitd - rstar) - d;
u_bitd_2 = - a * (pi_bitd - epi_bitd);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (inflation targeter) - Phillips Curve
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a = 1/0.8;
pistar = 2;
lambda = 0;
root = 1;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bitdpc = max(I);
inde = find(i_bitdpc);
[K,invind] = setdiff(obs,inde);
pi_bitdpc(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bitdpc(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bitdpc = ones(1,size(d,2))*epi;
u_bitdpc = un +  b * (i_bitdpc - epi_bitdpc - rstar) - d;
u_bitdpc_2 = - a * (pi_bitdpc - epi_bitdpc);
a = 1/1.2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (inflation targeter) - low IS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pistar = 2;
lambda = 0;
root = 1;
b = 0.1;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bitdis = max(I);
inde = find(i_bitdis);
[K,invind] = setdiff(obs,inde);
pi_bitdis(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bitdis(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bitdis = ones(1,size(d,2))*epi;

b = 0.2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (inflation targeter)- high rstar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0;
root = 1;
rstar = 3;
r1 = rstar;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bitdr = max(I);
inde = find(i_bitdr);
[K,invind] = setdiff(obs,inde);
pi_bitdr(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bitdr(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bitdr = ones(1,size(d,2))*epi;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (inflation targeter)- very high rstar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0;
root = 2;
rstar = 6;
r2 = rstar;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;

if root == 2
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bitdhr = max(I);
inde = find(i_bitdhr);
[K,invind] = setdiff(obs,inde);
pi_bitdhr(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bitdhr(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bitdhr = ones(1,size(d,2))*epi;
u_bitdhr = un +  b * (i_bitdhr - epi_bitdhr - rstar) - d;
u_bitdhr_2 = - a * (pi_bitdhr - epi_bitdhr);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rstar = 0;
lambda = 0.5;
root = 1;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmd = max(I);
inde = find(i_bdmd);
[K,invind] = setdiff(obs,inde);
pi_bdmd(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmd(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
prob_nzlb_bdmd = size(inde,2)/size(d,2);
epi_bdmd = ones(1,size(d,2))*epi;
u_bdmd = un + b * (i_bdmd - epi_bdmd - rstar) - d;
u_bdmd_2 = - a * (pi_bdmd - epi_bdmd);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - really high rstar (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rstar = 6;
lambda = 0.5;
root = 1;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmdhr = max(I);
inde = find(i_bdmdhr);
[K,invind] = setdiff(obs,inde);
pi_bdmdhr(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmdhr(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
prob_nzlb_bdmdhr = size(inde,2)/size(d,2);
epi_bdmdhr = ones(1,size(d,2))*epi;
u_bdmdhr = un + b * (i_bdmdhr - epi_bdmdhr - rstar) - d;
u_bdmdhr_2 = - a * (pi_bdmdhr - epi_bdmdhr);

rstar = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - rstar (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rstar = 3;
lambda = 0.5;
root = 1;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmdr = max(I);
inde = find(i_bdmdr);
[K,invind] = setdiff(obs,inde);
pi_bdmdr(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmdr(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
prob_nzlb_bdmdr = size(inde,2)/size(d,2);
epi_bdmdr = ones(1,size(d,2))*epi;
u_bdmdr = un +  b * (i_bdmdr - epi_bdmdr - rstar) - d;
u_bdmdr_2 = - a * (pi_bdmdr - epi_bdmdr);
rstar = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (dual mandate)low PC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a = 1/0.8;
rstar = 0;
lambda = 0.5;
root = 1;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmdpc = max(I);
inde = find(i_bdmdpc);
[K,invind] = setdiff(obs,inde);
pi_bdmdpc(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmdpc(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bdmdpc = ones(1,size(d,2))*epi;

a = 1/1.2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (dual mandate) low IS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pistar = 2; 
rstar = 0;
lambda = 0.5;
root = 1;
b = 0.15;
a = 1/1.2;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_bdmdis = max(I);
inde = find(i_bdmdis);
[K,invind] = setdiff(obs,inde);
pi_bdmdis(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_bdmdis(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_bdmdis = ones(1,size(d,2))*epi;

b = 0.2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - higher pistar (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0.5;
pistar = 3;
root = 1;
a = 1/(1.2);
p2 = pistar;
b = 0.2;
rstar = 0;

A = -0.5;
B = (b * (a^2*lambda + 1) * l + a*u ) / (a + b * (a^2*lambda+1) );
X = (u * pistar)/(a^2*lambda + 1) - (l^2) / ( 2 * a) - (b * l * rstar) / a;
Y = - ( b * (a^2*lambda + 1) * l + a * u )/(a + b * (a^2*lambda + 1)) * (a * pistar - b * (a^2*lambda + 1) * rstar);
C = 1/(a^2*lambda + 1) * Y + a * X;
if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

epi = - (a^2*lambda + 1) * d_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar + (a^2*lambda + 1)*d); 
I  = [iu;zer];
i_stdmd = max(I);
inde = find(i_stdmd);
[K,invind] = setdiff(obs,inde);
pi_stdmd(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar);
pi_stdmd(invind) = 1 / a * ( (a + b) * epi + b * rstar + d(invind));
epi_stdmd = ones(1,size(d,2))*epi;

end

%% Other graphs
if no_plot ~= 1

if version ~= 3

% FIGURE 1     
figure1a = figure;
axes1a = axes('Parent',figure1a);
h1 = plot(d,i_bitd);
hold on
h2 = plot(d,pi_bitd);
hold on
h6 = plot(d,epi_bitd);
hold on
h3 = plot(d,i_bitdr);
hold on
h4 = plot(d,pi_bitdr);
hold on
h7 = plot(d,epi_bitdr);
hold off
h5 = xlabel('Demand Shock');
set(h5, 'FontSize', 18) 
h9 = ylabel('Percentage');
set(h9, 'FontSize', 18) 
formatSpec = '%s %s %d';

lstrh1 = sprintf(formatSpec,II,R,r0);
lstrh2 = sprintf(formatSpec,PI,R,r0);
lstrh3 = sprintf(formatSpec,EPI,R,r0);
lstrh4 = sprintf(formatSpec,II,R,r1);
lstrh5 = sprintf(formatSpec,PI,R,r1);
lstrh6 = sprintf(formatSpec,EPI,R,r1);


set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
set(h6,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh3,'LineWidth',1);
set(h3,'Color',[0.7,0,0]','DisplayName',lstrh4,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh5,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h7,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh6,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',1);

legend1a = legend(axes1a,'show');
set(legend1a,'Location','northwest','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
%Name latex code
%fn = 'Figure_Demand1a';
%Name paper
fn = 'Figure1_b';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )

figure1b = figure;
axes1b = axes('Parent',figure1b);
h3 = plot(d,i_bitdhr);
hold on
h6 = plot(d,epi_bitdhr);
hold on
h4 = plot(d,pi_bitdhr);
hold off
h5 = xlabel('Demand Shock');
set(h5, 'FontSize', 18) 
h9 = ylabel('Percentage');
set(h9, 'FontSize', 18) 
formatSpec = '%s %s %d';
lstrh3 = sprintf(formatSpec,II,R,r2);
lstrh4 = sprintf(formatSpec,PI,R,r2);
lstrh6 = sprintf(formatSpec,EPI,R,r2);

set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
set(h6,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);

legend1b = legend(axes1b,'show');
set(legend1b,'Location','northwest','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
%Name Latex Code:
%fn = 'Figure_Demand1b';
%Name Paper
fn = 'Figure1_a';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )


% FIGURE 2
figure2 = figure;
axes2 = axes('Parent',figure2);
h1 = plot(d,i_bitd);
hold on
h2 = plot(d,pi_bitd);
hold on
h6 = plot(d,epi_bitd);
hold on
h3 = plot(d,i_bdmd);
hold on
h7 = plot(d,epi_bdmd);
hold on
h4 = plot(d,pi_bdmd);
hold off
h5 = xlabel('Demand Shock');
set(h5, 'FontSize', 18) 
h9 = ylabel('Percentage');
set(h9, 'FontSize', 18) 
formatSpec = '%s %s';
lstrh1 = sprintf(formatSpec,II,IT);
lstrh2 = sprintf(formatSpec,PI,IT);
lstrh6 = sprintf(formatSpec,EPI,IT);

lstrh3 = sprintf(formatSpec,II,DM);
lstrh4 = sprintf(formatSpec,PI,DM);
lstrh7 = sprintf(formatSpec,EPI,DM);


set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
set(h6,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);

set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h7,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh7,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',1);
legend2 = legend(axes2,'show');
set(legend2,'Location','northwest','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Name latex
%fn = 'Figure_Demand2_dm';
% Name Paper
fn = 'Figure2_a';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )

figure2f = figure;
axes2f = axes('Parent',figure2f);
% h1 = plot(d,i_bitd);
% hold on
% h2 = plot(d,pi_bitd);
% hold on
% h6 = plot(d,epi_bitd);
% hold on
% h3 = plot(d,i_bdmd);
% hold on
% h7 = plot(d,epi_bdmd);
% hold on
% h4 = plot(d,pi_bdmd);
% hold on
h10 = plot(d, (u_bitd-un));
hold on
h11 = plot(d,(u_bdmd-un));
hold on
% h12 = plot(d,un*ones(size(u_bdmdr,2)));
% hold on
h13 = plot(d,0*ones(size(u_bdmdr,2)));
hold off
h5 = xlabel('Demand Shock');
set(h5, 'FontSize', 18) 
h9 = ylabel('Percentage');
set(h9, 'FontSize', 18) 
formatSpec = '%s %s';
% lstrh1 = sprintf(formatSpec,II,IT);
% lstrh2 = sprintf(formatSpec,PI,IT);
% lstrh6 = sprintf(formatSpec,EPI,IT);
% 
% lstrh3 = sprintf(formatSpec,II,DM);
% lstrh4 = sprintf(formatSpec,PI,DM);
% lstrh7 = sprintf(formatSpec,EPI,DM);

lstrh8 = sprintf(formatSpec,U,IT);
lstrh9 = sprintf(formatSpec,U,DM);


% set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
% set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
% set(h6,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);
% 
% set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
% set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
% set(h7,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh7,'LineWidth',1);

set(h10,'Color',[0 0 1],'LineStyle','-', 'DisplayName',lstrh8,'LineWidth',1);
set(h11,'Color',[0.7 0 0],'LineStyle','-','Marker','o' ,'MarkerIndices', 1:40:length(d), 'DisplayName',lstrh9,'LineWidth',1);
% set(h12,'Color',[0 0 0],'LineStyle','-','LineWidth',1);
set(h13,'Color',[0 0 0],'LineStyle','-','LineWidth',1);


legend2f = legend([h10 h11]);
set(legend2f,'Location','northeast','FontSize',16,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex name
%fn = 'Figure_Demand2_dm_u2';
% Paper name
fn = 'Figure2_b';

set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )

figure2a = figure;
axes2a = axes('Parent',figure2a);
h1 = plot(d,i_bdmdpc);
hold on
h2 = plot(d,pi_bdmdpc);
hold on
h6 = plot(d,epi_bdmdpc);
hold on
h3 = plot(d,i_bdmd);
hold on
h7 = plot(d,epi_bdmd);
hold on
h4 = plot(d,pi_bdmd);
hold off
h5 = xlabel('Demand Shock');
set(h5, 'FontSize', 18) 
h9 = ylabel('Percentage');
set(h9, 'FontSize', 18) 
formatSpec = '%s %s';
lstrh1 = sprintf(formatSpec,II,' - Flatter PC');
lstrh2 = sprintf(formatSpec,PI,' - Flatter PC');
lstrh6 = sprintf(formatSpec,EPI,' - Flatter PC');

lstrh3 = sprintf(formatSpec,II,' - Baseline');
lstrh4 = sprintf(formatSpec,PI,' - Baseline PC');
lstrh7 = sprintf(formatSpec,EPI,' - Baseline PC');

set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
set(h6,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);

set(h3,'Color',[0.7,0,0]','LineStyle','-','DisplayName',lstrh3,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h7,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh7,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',1);

legend2a = legend(axes2a,'show');
set(legend2a,'Location','northwest','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Name latex
%fn = 'Figure_Demand2PC';
% Name paper
fn = 'Figure3_a';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )


figure8a = figure;
axes8a = axes('Parent',figure8a);
h1 = plot(d,i_bdmdis);
hold on
h2 = plot(d,pi_bdmdis);
hold on
h6 = plot(d,epi_bdmdis);
hold on
h3 = plot(d,i_bdmd);
hold on
h7 = plot(d,epi_bdmd);
hold on
h4 = plot(d,pi_bdmd);
hold off
h5 = xlabel('Dual Mandate - Demand Shock');
set(h5, 'FontSize', 18) 
h9 = ylabel('Percentage');
set(h9, 'FontSize', 18) 
formatSpec = '%s %s';
lstrh1 = sprintf(formatSpec,II,' - Steeper IS');
lstrh2 = sprintf(formatSpec,PI,' - Steeper IS');
lstrh6 = sprintf(formatSpec,EPI,' - Steeper IS');

lstrh3 = sprintf(formatSpec,II,' - Baseline');
lstrh4 = sprintf(formatSpec,PI,' - Baseline');
lstrh7 = sprintf(formatSpec,EPI,' - Baseline');

set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
set(h6,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);

set(h3,'Color',[0.7,0,0]','LineStyle','-','DisplayName',lstrh3,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h7,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh7,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',1);

legend8a = legend(axes8a,'show');
set(legend8a,'Location','northwest','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Name Latex
%fn = 'Figure_Demand2IS';
% Name paper
fn = 'Figure3_b';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )


end
end

%% Supply shocks 

root = 2;
lambda = 0;
rstar = 0;
pistar = 2;

if version == 2
a = 1/(1.2);
s = grid_2;
l = l_2;
u = u_2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Supply - baseline (inflation targeter)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
lambda=0;
A = -0.5;
B = (b * (a^2*lambda + 1) * u + a*l ) / (a + b * (a^2*lambda+1) );
X = - (l * pistar)/(a^2*lambda + 1) + ( a * lambda * l^2) / ( 2 * (a^2*lambda + 1)) + (b * u * rstar) / a - (u^2) / (2 * a);
Y = ( b * (a^2*lambda + 1) * u + a * l ) * ( (a * pistar ) / ( a + b * (a^2*lambda + 1)) - (b * (a^2*lambda + 1) * rstar) / ( a + b * (a^2*lambda + 1)));
C = Y + a * (a^2*lambda + 1) * X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(s_bar)

epi = s_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

disp(epi)

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar - s); 
I  = [iu;zer];
i_bits = max(I);
inde = find(i_bits);
[K,invind] = setdiff(obs,inde);
pi_bits(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar - a * lambda .* s(inde));
pi_bits(invind) = 1 / a * ( (a + b) * epi + b * rstar - s(invind));
epi_bits = ones(1,size(d,2))*epi;
u_bits = un + b * (i_bits - epi_bits - rstar) ;
u_bits_2 = - a * (pi_bits - epi_bits) - s;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Supply - baseline (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda=0.5;
A = -0.5;
B = (b * (a^2*lambda + 1) * u + a*l ) / (a + b * (a^2*lambda+1) );
X = - (l * pistar)/(a^2*lambda + 1) + ( a * lambda * l^2) / ( 2 * (a^2*lambda + 1)) + (b * u * rstar) / a - (u^2) / (2 * a);
Y = ( b * (a^2*lambda + 1) * u + a * l ) * ( (a * pistar ) / ( a + b * (a^2*lambda + 1)) - (b * (a^2*lambda + 1) * rstar) / ( a + b * (a^2*lambda + 1)));
C = Y + a * (a^2*lambda + 1) * X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(s_bar)

epi = s_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

disp(epi)

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar - s); 
I  = [iu;zer];
i_bdms = max(I);
inde = find(i_bdms);
[K,invind] = setdiff(obs,inde);
pi_bdms(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar - a * lambda .* s(inde));
pi_bdms(invind) = 1 / a * ( (a + b) * epi + b * rstar - s(invind));
prob_nzlb_bdms = size(inde,2)/size(s,2);
epi_bdms = ones(1,size(d,2))*epi;
u_bdms = un + b * (i_bdms - epi_bdms - rstar) ;
u_bdms_2 = - a * (pi_bdms - epi_bdms) - s;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Supply - baseline (dual mandate) - steeper IS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda=0.5;
A = -0.5;
b = 0.15;

B = (b * (a^2*lambda + 1) * u + a*l ) / (a + b * (a^2*lambda+1) );
X = - (l * pistar)/(a^2*lambda + 1) + ( a * lambda * l^2) / ( 2 * (a^2*lambda + 1)) + (b * u * rstar) / a - (u^2) / (2 * a);
Y = ( b * (a^2*lambda + 1) * u + a * l ) * ( (a * pistar ) / ( a + b * (a^2*lambda + 1)) - (b * (a^2*lambda + 1) * rstar) / ( a + b * (a^2*lambda + 1)));
C = Y + a * (a^2*lambda + 1) * X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(s_bar)

epi = s_bar/(a + b * (a^2*lambda + 1)) + (a * pistar) / (a + b * (a^2*lambda + 1)) - ( b  * (a^2*lambda + 1) * rstar) / (a + b * (a^2*lambda + 1));

disp(epi)

iu = rstar + 1/( b * (a^2*lambda + 1)) * ((a + b * (a^2*lambda + 1)) * epi - a * pistar - s); 
I  = [iu;zer];
i_bdmsis = max(I);
inde = find(i_bdmsis);
[K,invind] = setdiff(obs,inde);
pi_bdmsis(inde) = 1 / (a^2*lambda + 1) * (a^2 * lambda * epi + pistar - a * lambda .* s(inde));
pi_bdmsis(invind) = 1 / a * ( (a + b) * epi + b * rstar - s(invind));
epi_bdmsis = ones(1,size(d,2))*epi;
u_bdmsis = un + b * (i_bdmsis - epi_bdmsis - rstar);
u_bdmsis_2 = - a * (pi_bdmsis - epi_bdmsis) - s;

end

%% Other figures 
if no_plot ~= 1

if version ~= 3    
    
% Figure 4    

figure4 = figure;
axes4 = axes('Parent',figure4);
h1 = plot(s,i_bits);
hold on
h2 = plot(s,pi_bits);
hold on
h7 = plot(s,epi_bits);
hold on
h3 = plot(s,i_bdms);
hold on
h8 = plot(s,epi_bdms);
hold on
h4 = plot(s,pi_bdms);
hold off
h5 = xlabel('Supply Shock');
set(h5, 'FontSize', 18) 
h6 = ylabel('Percentage');
set(h6, 'FontSize', 18) 
formatSpec = '%s %s';
lstrh1 = sprintf(formatSpec,II,IT);
lstrh2 = sprintf(formatSpec,PI,IT);
lstrh7 = sprintf(formatSpec,EPI,IT);
lstrh3 = sprintf(formatSpec,II,DM);
lstrh4 = sprintf(formatSpec,PI,DM);
lstrh8 = sprintf(formatSpec,EPI,DM);

set(h1,'Color',[0,0.5,0],'LineStyle','-','DisplayName',lstrh1,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h2,'Color',[0,0.5,0],'LineStyle',':','DisplayName',lstrh2,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h7,'Color',[0,0.6,0],'LineStyle','--','DisplayName',lstrh7,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',1);

set(h3,'Color',[0,0,0]','DisplayName',lstrh3,'LineWidth',2);
set(h4,'Color',[0,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
set(h8,'Color',[0.2,0,0],'LineStyle',':','DisplayName',lstrh8,'LineWidth',1);
xlim([-1.25 1.25])

legend4 = legend(axes4,'show');
set(legend4,'Location','northeast','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Name latex
%fn = 'Figure_Supply2';
% Name Paper
fn = 'Figure4_a';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )



figure9a = figure;
axes9a = axes('Parent',figure9a);
% h1 = plot(d,i_bitd);
% hold on
% h2 = plot(d,pi_bitd);
% hold on
% h6 = plot(d,epi_bitd);
% hold on
% h3 = plot(d,i_bdmd);
% hold on
% h7 = plot(d,epi_bdmd);
% hold on
% h4 = plot(d,pi_bdmd);
% hold on
h10 = plot(s, (u_bits-un));
hold on
h11 = plot(s,(u_bdms-un));
hold on
% h12 = plot(d,un*ones(size(u_bdmdr,2)));
% hold on
h13 = plot(s,0*ones(size(u_bdms,2)));
hold off
h5 = xlabel('Supply Shock');
set(h5, 'FontSize', 18) 
h9 = ylabel('Percentage');
set(h9, 'FontSize', 18) 
formatSpec = '%s %s';
% lstrh1 = sprintf(formatSpec,II,IT);
% lstrh2 = sprintf(formatSpec,PI,IT);
% lstrh6 = sprintf(formatSpec,EPI,IT);
% 
% lstrh3 = sprintf(formatSpec,II,DM);
% lstrh4 = sprintf(formatSpec,PI,DM);
% lstrh7 = sprintf(formatSpec,EPI,DM);

lstrh8 = sprintf(formatSpec,U,IT);
lstrh9 = sprintf(formatSpec,U,DM);


% set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
% set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
% set(h6,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);
% 
% set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
% set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
% set(h7,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh7,'LineWidth',1);

set(h10,'Color',[0,0.5,0],'LineStyle','-','Marker','o' ,'MarkerIndices', 1:40:length(d), 'DisplayName',lstrh8,'LineWidth',1);
set(h11,'Color',[0 0 0],'LineStyle','-', 'DisplayName',lstrh9,'LineWidth',1);
% set(h12,'Color',[0 0 0],'LineStyle','-','LineWidth',1);
set(h13,'Color',[0 0 0],'LineStyle','-','LineWidth',1);
xlim([-1.25 1.25])


legend9a = legend([h10 h11]);
set(legend9a,'Location','northeast','FontSize',16,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Name Latex
%fn = 'Figure_Supply_u2';
% Name Paper
fn = 'Figure4_b';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )

end
end
%% Shortfall
pistar = 2;

if version == 2
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - demand
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
d = grid;
lambda = 0.5;
a = 1/1.2;
root = 1; 
b = 0.2;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(d_bar)

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

disp(epi)

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmd  = max(I);
inde = find(i_shdmd);
[K,invind] = setdiff(obs,inde);
pi_shdmd(inde) = pistar + a * lambda;
pi_shdmd(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
prob_nzlb_shdmd = size(inde,2)/size(d,2);
epi_shdmd = ones(1,size(d,2))*epi;
u_shdmd = un +  b * (i_shdmd - epi_shdmd - rstar) - d;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - demand - high r star
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rstar = 6;
d = grid;
lambda = 0.5;
a = 1/1.2;
root = 1; 
b = 0.2;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(d_bar)

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

disp(epi)

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdhr  = max(I);
inde = find(i_shdmdhr);
[K,invind] = setdiff(obs,inde);
pi_shdmdhr(inde) = pistar + a * lambda;
pi_shdmdhr(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
prob_nzlb_shdmdhr = size(inde,2)/size(d,2);
epi_shdmdhr = ones(1,size(d,2))*epi;
u_shdmdhr = un + b * (i_shdmdhr - epi_shdmdhr - rstar) - d;


rstar = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - demand - r star
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rstar = 3;
d = grid;
lambda = 0.5;
a = 1/1.2;
root = 1; 
b = 0.2;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(d_bar)

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

disp(epi)

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdr  = max(I);
inde = find(i_shdmdr);
[K,invind] = setdiff(obs,inde);
pi_shdmdr(inde) = pistar + a * lambda;
pi_shdmdr(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
prob_nzlb_shdmdr = size(inde,2)/size(d,2);
epi_shdmdr = ones(1,size(d,2))*epi;
u_shdmdr = un + b * (i_shdmdr - epi_shdmdr - rstar) - d;

rstar = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - demand - steep PC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
d = grid;
lambda = 0.5;
a = 1/0.8;
root = 1; 
b = 0.2;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(d_bar)

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

disp(epi)

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdpc  = max(I);
inde = find(i_shdmdpc);
[K,invind] = setdiff(obs,inde);
pi_shdmdpc(inde) = pistar + a * lambda;
pi_shdmdpc(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
prob_nzlb_shdmdpc = size(inde,2)/size(d,2);
epi_shdmdpc = ones(1,size(d,2))*epi;
a = 1/1.2;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - supply
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
l = l_2;
u = u_2;
lambda = 0.5;
a = 1/1.2;
root = 2;
s = grid_2;
b = 0.2;

A = -0.5;
B = (b*u+a*l)/(a+b);
X = -(a*lambda + pistar)*l+(b*rstar*u)/a - (u^2)/(2*a);
Y = (b*u + a*l) * ((a^2*lambda - b * rstar + a * pistar)/(a + b)); 
C = Y + a*X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(s_bar)

epi = (a^2*lambda - b*rstar + a * pistar)/(a+b) + 1/(a + b) * s_bar;

disp(epi)

iu = rstar + 1/b * ((a+b)*epi - a^2*lambda - a*pistar) - 1/b * s;
I  = [iu;zer];
i_shdms  = max(I);
inde = find(i_shdms);
[K,invind] = setdiff(obs,inde);
pi_shdms(inde) = pistar + a * lambda;
pi_shdms(invind) = (a + b)/ a * epi - 1/a .*s(invind) + (b * rstar) / a;
prob_nzlb_shdms = size(inde,2)/size(s,2);
epi_shdms = ones(1,size(d,2))*epi;
u_shdms = un +  b * (i_shdms - epi_shdms - rstar);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - demand - steeper IS 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
d = grid;
lambda = 0.5;
a = 1/1.2;
root = 1; 
b = 0.15;

A = -0.5;
B = (b*l+a*u)/(a+b);
X = -(b*rstar*l)/a - (l^2)/(2*a) + (a*lambda + pistar) * u;
Y = - (b*l + a*u) * (( a*pistar - b*rstar + a^2*lambda)/(a+b));
C = Y + a*X;

if root == 1
d_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
d_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(d_bar)

epi = - d_bar/(a + b) + (a * pistar) / (a + b) - ( b * rstar) / (a + b) + (a^2 * lambda)/(a + b);

disp(epi)

iu = rstar + (a + b) / b * epi + (1 / b) * d - (a^2 * lambda) / b - (a * pistar) / b;
I  = [iu;zer];
i_shdmdis  = max(I);
inde = find(i_shdmdis);
[K,invind] = setdiff(obs,inde);
pi_shdmdis(inde) = pistar + a * lambda;
pi_shdmdis(invind) = (a + b)/ a * epi + (b * rstar)/a + (1 / a) .*d(invind);
epi_shdmdis = ones(1,size(d,2))*epi;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - supply - steeper IS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
l = l_2;
u = u_2;
lambda = 0.5;
root = 2;
s = grid_2;
b = 0.15;

A = -0.5;
B = (b*u+a*l)/(a+b);
X = -(a*lambda + pistar)*l+(b*rstar*u)/a - (u^2)/(2*a);
Y = (b*u + a*l) * ((a^2*lambda - b * rstar + a * pistar)/(a + b)); 
C = Y + a*X;

if root == 1
s_bar = (-B+(B^2-4*A*C)^0.5)/(2*A);
else 
s_bar = (-B-(B^2-4*A*C)^0.5)/(2*A);
end

disp(s_bar)

epi = (a^2*lambda - b*rstar + a * pistar)/(a+b) + 1/(a + b) * s_bar;

disp(epi)

iu = rstar + 1/b * ((a+b)*epi - a^2*lambda - a*pistar) - 1/b * s;
I  = [iu;zer];
i_shdmsis  = max(I);
inde = find(i_shdmsis);
[K,invind] = setdiff(obs,inde);
pi_shdmsis(inde) = pistar + a * lambda;
pi_shdmsis(invind) = (a + b)/ a * epi - 1/a .*s(invind) + (b * rstar) / a;
prob_nzlb_shdms = size(inde,2)/size(s,2);
epi_shdmsis = ones(1,size(d,2))*epi;

end

%% Other graphs

if no_plot ~= 1

if version ~= 3

% Figure 5

figure5 = figure;
axes5 = axes('Parent',figure5);
h1 = plot(d,i_shdmd);
hold on
h2 = plot(d,pi_shdmd);
hold on
h5 = plot(d,epi_shdmd);
hold on
h3 = plot(d,i_bdmd);
hold on
h6 = plot(d,epi_bdmd);
hold on
h4 = plot(d,pi_bdmd);
hold off
h7 = xlabel('Demand Shock');
set(h7, 'FontSize', 18) 
h8 = ylabel('Percentage');
set(h8, 'FontSize', 18) 
lstrh1 = sprintf(formatSpec,II,' - \lq\lq{}shortfalls\rq\rq{}');
lstrh2 = sprintf(formatSpec,PI,' - \lq\lq{}shortfalls\rq\rq{}');
lstrh3 = sprintf(formatSpec,II,' - \lq\lq{}deviations\rq\rq{}');
lstrh4 = sprintf(formatSpec,PI,' - \lq\lq{}deviations\rq\rq{}');
lstrh5 = sprintf(formatSpec,EPI,' - \lq\lq{}shortfalls\rq\rq{}');
lstrh6 = sprintf(formatSpec,EPI,' - \lq\lq{}deviations\rq\rq{}');

set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
set(h5,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh5,'LineWidth',1);

set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',2);
set(h6,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh6,'Marker','o' ,'MarkerIndices', 1:40:length(d),'LineWidth',1);


legend5 = legend(axes5,'show');
set(legend5,'Location','northwest','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex name
%fn = 'Figure_Shortfalls';
% Paper name
fn = 'Figure5_a';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )    



figure5f = figure;
axes5f = axes('Parent',figure5f);
% h1 = plot(d,i_shdmd);
% hold on
% h2 = plot(d,pi_shdmd);
% hold on
% h5 = plot(d,epi_shdmd);
% hold on
% h3 = plot(d,i_bdmd);
% hold on
% h6 = plot(d,epi_bdmd);
% hold on
% h4 = plot(d,pi_bdmd);
% hold on
h10 = plot(d,(u_shdmd-un));
hold on
h11 = plot(d,(u_bdmd-un));
hold on
% h12 = plot(d,un*ones(size(u_bdmd,2)));
% hold on
h13 = plot(d,0*ones(size(u_bdmd,2)));
hold off
h7 = xlabel('Demand Shock');
set(h7, 'FontSize', 18) 
h8 = ylabel('Percentage');
set(h8, 'FontSize', 18) 
% lstrh1 = sprintf(formatSpec,II,' - \lq\lq{}shortfalls\rq\rq{}');
% lstrh2 = sprintf(formatSpec,PI,' - \lq\lq{}shortfalls\rq\rq{}');
% lstrh3 = sprintf(formatSpec,II,' - \lq\lq{}deviations\rq\rq{}');
% lstrh4 = sprintf(formatSpec,PI,' - \lq\lq{}deviations\rq\rq{}');
% lstrh5 = sprintf(formatSpec,EPI,' - \lq\lq{}shortfalls\rq\rq{}');
% lstrh6 = sprintf(formatSpec,EPI,' - \lq\lq{}deviations\rq\rq{}');
lstrh7 = sprintf(formatSpec,U,' - \lq\lq{}shortfalls\rq\rq{}');
lstrh8 = sprintf(formatSpec,U,' - \lq\lq{}deviations\rq\rq{}');

% set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
% set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
% set(h5,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh5,'LineWidth',1);
% 
% set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
% set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
% set(h6,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);
set(h10,'Color',[0 0 1],'LineStyle','-','DisplayName',lstrh7,'LineWidth',1);
set(h11,'Color',[0.7 0 0],'LineStyle','-','Marker','o' ,'MarkerIndices', 1:40:length(d), 'DisplayName',lstrh8,'LineWidth',1);
% set(h12,'Color',[0 0 0],'LineStyle','-','LineWidth',1);
set(h13,'Color',[0 0 0],'LineStyle','-','LineWidth',1);


legend5f = legend([h10 h11]);
set(legend5f,'Location','Northeast','FontSize',14,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex Name
%fn = 'Figure_Shortfalls_dm_u2';
% Paper name
fn = 'Figure5_c';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )    


figure5i = figure;
axes5i = axes('Parent',figure5i);
% h1 = plot(d,i_shdmd);
% hold on
% h2 = plot(d,pi_shdmd);
% hold on
% h5 = plot(d,epi_shdmd);
% hold on
% h3 = plot(d,i_bdmd);
% hold on
% h6 = plot(d,epi_bdmd);
% hold on
% h4 = plot(d,pi_bdmd);
% hold on
h10 = plot(s,(u_shdms-un));
hold on
h11 = plot(s,(u_bdms-un));
hold on
% h12 = plot(d,un*ones(size(u_bdmd,2)));
% hold on
h13 = plot(s,0*ones(size(u_bdms,2)));
hold off
h7 = xlabel('Supply Shock');
set(h7, 'FontSize', 18) 
h8 = ylabel('Percentage');
set(h8, 'FontSize', 18) 
% lstrh1 = sprintf(formatSpec,II,' - \lq\lq{}shortfalls\rq\rq{}');
% lstrh2 = sprintf(formatSpec,PI,' - \lq\lq{}shortfalls\rq\rq{}');
% lstrh3 = sprintf(formatSpec,II,' - \lq\lq{}deviations\rq\rq{}');
% lstrh4 = sprintf(formatSpec,PI,' - \lq\lq{}deviations\rq\rq{}');
% lstrh5 = sprintf(formatSpec,EPI,' - \lq\lq{}shortfalls\rq\rq{}');
% lstrh6 = sprintf(formatSpec,EPI,' - \lq\lq{}deviations\rq\rq{}');
lstrh7 = sprintf(formatSpec,U,' - \lq\lq{}shortfalls\rq\rq{}');
lstrh8 = sprintf(formatSpec,U,' - \lq\lq{}deviations\rq\rq{}');

% set(h1,'Color',[0,0,1],'LineStyle','-','DisplayName',lstrh1,'LineWidth',2);
% set(h2,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh2,'LineWidth',2);
% set(h5,'Color',[0,0,0.8],'LineStyle','--','DisplayName',lstrh5,'LineWidth',1);
% 
% set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
% set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
% set(h6,'Color',[0.5,0,0],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);
set(h10,'Color',[0 0.5 0],'LineStyle','-','Marker','o' ,'MarkerIndices', 1:40:length(d), 'DisplayName',lstrh7,'LineWidth',1);
set(h11,'Color',[0 0 0],'LineStyle','-', 'DisplayName',lstrh8,'LineWidth',1);
% set(h12,'Color',[0 0 0],'LineStyle','-','LineWidth',1);
set(h13,'Color',[0 0 0],'LineStyle','-','LineWidth',1);
xlim([-1.25 1.25])


legend5i = legend([h10 h11]);
set(legend5i,'Location','Northeast','FontSize',14,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex name
%fn = 'Figure_Shortfalls_s_u2';
% Paper name
fn = 'Figure5_d';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )    



figure5a = figure;
axes5a = axes('Parent',figure5a);
h1 = plot(s,i_shdms);
hold on
h2 = plot(s,pi_shdms);
hold on
h5 = plot(s,epi_shdms);
hold on
h3 = plot(s,i_bdms);
hold on
h6 = plot(s,epi_bdms);
hold on
h4 = plot(s,pi_bdms);
hold off
h7 = xlabel('Supply Shock');
set(h7, 'FontSize', 18) 
h8 = ylabel('Percentage');
set(h8, 'FontSize', 18) 
lstrh1 = sprintf(formatSpec,II,' - \lq\lq{}shortfalls\rq\rq{}');
lstrh2 = sprintf(formatSpec,PI,' - \lq\lq{}shortfalls\rq\rq{}');
lstrh3 = sprintf(formatSpec,II,' - \lq\lq{}deviations\rq\rq{}');
lstrh4 = sprintf(formatSpec,PI,' - \lq\lq{}deviations\rq\rq{}');
lstrh5 = sprintf(formatSpec,EPI,' - \lq\lq{}shortfalls\rq\rq{}');
lstrh6 = sprintf(formatSpec,EPI,' - \lq\lq{}deviations\rq\rq{}');

set(h1,'Color',[0,0.5,0],'LineStyle','-','Marker','o' ,'MarkerIndices', 1:40:length(d),'DisplayName',lstrh1,'LineWidth',2);
set(h2,'Color',[0,0.5,0],'LineStyle',':','Marker','o' ,'MarkerIndices', 1:40:length(d),'DisplayName',lstrh2,'LineWidth',2);
set(h5,'Color',[0,0.7,0],'LineStyle','--','Marker','o' ,'MarkerIndices', 1:40:length(d),'DisplayName',lstrh5,'LineWidth',1);

set(h3,'Color',[0,0,0]','DisplayName',lstrh3,'LineWidth',2);
set(h4,'Color',[0,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
set(h6,'Color',[0.2,0,0],'LineStyle','--','DisplayName',lstrh6,'LineWidth',1);
xlim([-1.25 1.25])

legend5a = legend(axes5a,'show');
set(legend5a,'Location','northeast','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex Name
%fn = 'Figure_ShortfallsS';
% Papepr name
fn = 'Figure5_b';
set(gca,'fontsize',16) 
print( gcf, '-dpdf', fn )


end
end
