%Codes to Replicate - The Deflationary Bias of the ZLB and the FED's Strategic Response
%Figures 6-7
%by Adrian Penalver and Daniele Siena
%JMCB January 2024

clear all
close all
clc

% Set common parameters 
u = 1.5;
l = -u;
sca = 201;
grid = linspace(l,u,sca);
u_2 = 1.5/1.2;
l_2 = -u_2;
sca = 201;
grid_2 = linspace(l_2,u_2,sca);
un = 5; 
b = 0.2;
pistar = 2;
p1 = pistar;
rstar = 0;
zer = zeros(1,sca);
pi_bitd = zeros(1,sca);
obs = linspace(1,sca,sca);
%%
% model parameters for other rapresentation - Formulation II (different
% than for FIGURE 1-5) - same results
a = 1.2;

b = 0.2;
pistar = 2;
p1 = pistar;
rstar = 0;

% grids
r0 = rstar;

II = '$i$';
R = '$r^{\ast} = $';
PI = '$\pi$';
EPI = '$E(\pi)$';
PIS = '$\pi^{\ast} =$';
IT = '- IT';
DM = '- DM';
U = '$(U - U^{*})$ - Unemployment gap';

d = grid;

%% Version 1 - AP specification

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (inflation targeter)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar)/(b*(lambda+a^2))+d./b;
I  = [iu;zer];
i_bitd = max(I);
inde = find(i_bitd);
[K,invind] = setdiff(obs,inde);

pi_bitd(inde) = (lambda*epi+pistar*a^2)/(lambda+a^2);
pi_bitd(invind) = epi*(1+a*b)+a*b*rstar + a.*d(invind);
epi_bitd = ones(1,size(d,2))*epi;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (inflation targeter)- high rstar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0;
rstar = 3;
r1 = rstar;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar)/(b*(lambda+a^2))+d./b;
I  = [iu;zer];
i_bitdr = max(I);
inde = find(i_bitdr);
[K,invind] = setdiff(obs,inde);
pi_bitdr(inde) = (lambda*epi+pistar*a^2)/(lambda+a^2);
pi_bitdr(invind) = epi*(1+a*b)+a*b*rstar + a.*d(invind);
epi_bitdr = ones(1,size(d,2))*epi;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (inflation targeter)- very high rstar
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0;
rstar = 6;
r2 = rstar;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar)/(b*(lambda+a^2))+d./b;
I  = [iu;zer];
i_bitdhr = max(I);
inde = find(i_bitdhr);
[K,invind] = setdiff(obs,inde);
pi_bitdhr(inde) = (lambda*epi+pistar*a^2)/(lambda+a^2);
pi_bitdhr(invind) = epi*(1+a*b)+a*b*rstar + a.*d(invind);
epi_bitdhr = ones(1,size(d,2))*epi;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rstar = 0;
lambda = 0.5;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)

iu = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar)/(b*(lambda+a^2))+d./b;
I  = [iu;zer];
i_bdmd  = max(I);
inde = find(i_bdmd);
[K,invind] = setdiff(obs,inde);
pi_bdmd(inde) = (lambda*epi+pistar*a^2)/(lambda+a^2);
prob_nzlb_bdmd = size(inde,2)/size(d,2);
pi_bdmd(invind) = epi*(1+a*b)+a*b*rstar + a.*d(invind);
epi_bdmd = ones(1,size(d,2))*epi;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - baseline (dual mandate)low PC
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0.5;
a = 0.8;
d = grid;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar)/(b*(lambda+a^2))+d./b;
I  = [iu;zer];
i_bdmdpc  = max(I);
inde = find(i_bdmdpc);
[K,invind] = setdiff(obs,inde);
pi_bdmdpc(inde) = (lambda*epi+pistar*a^2)/(lambda+a^2);
pi_bdmdpc(invind) = epi*(1+a*b)+a*b*rstar + a.*d(invind);
epi_bdmdpc = ones(1,size(d,2))*epi;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Demand - higher pistar (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0.5;
pistar = 3;
p2 = pistar;
a = 1.2;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar)/(b*(lambda+a^2))+d./b;
I  = [iu;zer];
i_stdmd  = max(I);
inde = find(i_stdmd);
[K,invind] = setdiff(obs,inde);
pi_stdmd(inde) = (lambda*epi+pistar*a^2)/(lambda+a^2);
pi_stdmd(invind) = epi*(1+a*b)+a*b*rstar + a.*d(invind);
epi_stdmd = ones(1,size(d,2))*epi;

%% Supply shocks 

root = 2;
lambda = 0;
rstar = 0;
pistar = 2;

a = 1.2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Supply - baseline (inflation targeter)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0;
s = grid;
A = -0.5*(a*(1+a*b)+b*lambda)^2;
B = -(b*(lambda+a^2)*rstar - a*pistar)*(a*(1+a*b)+b*lambda)+a*b*(lambda+a^2)*u+l*a^2;
C = -0.5*(b*(a^2+lambda)*rstar-a*pistar)^2-pistar*l*a^2-0.5*(lambda+a^2)*u^2+a*b*(lambda+a^2)*u*rstar + 0.5*lambda*l^2;

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar-a.*s)/(b*(lambda+a^2));
I  = [iu;zer];
i_bits = max(I);
inde = find(i_bits);
[K,invind] = setdiff(obs,inde);
pi_bits(inde) = (lambda*epi+pistar*a^2-lambda.*s(inde))/(lambda+a^2);
pi_bits(invind) = epi*(1+a*b)+a*b*rstar -s(invind);
epi_bits = ones(1,size(d,2))*epi;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Supply - baseline (dual mandate)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0.5;

s = grid;
A = -0.5*(a*(1+a*b)+b*lambda)^2;
B = -(b*(lambda+a^2)*rstar - a*pistar)*(a*(1+a*b)+b*lambda)+a*b*(lambda+a^2)*u+l*a^2;
C = -0.5*(b*(a^2+lambda)*rstar-a*pistar)^2-pistar*l*a^2-0.5*(lambda+a^2)*u^2+a*b*(lambda+a^2)*u*rstar + 0.5*lambda*l^2;

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar-a.*s)/(b*(lambda+a^2));
I  = [iu;zer];
i_bdms = max(I);
inde = find(i_bdms);
prob_nzlb_bdms = size(inde,2)/size(d,2);
[K,invind] = setdiff(obs,inde);
pi_bdms(inde) = (lambda*epi+pistar*a^2-lambda.*s(inde))/(lambda+a^2);
pi_bdms(invind) = epi*(1+a*b)+a*b*rstar -s(invind);
epi_bdms = ones(1,size(d,2))*epi;


%% Shortfall
pistar = 2;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - demand
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a = 1.2;
lambda = 0.5;
u = 1.5;
l = -u;

A = -0.5*(1+a*b)^2;
B = (1+a*b)*(pistar+lambda/a-a*b*rstar)-a*(u+a*b*l);
C = -0.5*(pistar+lambda/a-a*b*rstar)^2+(a*pistar+lambda)*u-(a^2)*b*rstar*l-0.5*(a^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((1+a*b)*epi - pistar- lambda/a + a.*d)/(a*b);
I  = [iu;zer];
i_shdmd  = max(I);
inde = find(i_shdmd);
[K,invind] = setdiff(obs,inde);
prob_nzlb_shdmd = size(inde,2)/size(d,2);
pi_shdmd(inde) = pistar + lambda/a;
pi_shdmd(invind) = epi*(1+a*b)+a*b*rstar + a.*d(invind);
epi_shdmd = ones(1,size(d,2))*epi;
u_shdmd = un +  b * (i_shdmd - epi_shdmd - rstar) - d;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Shortfalls - supply
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambda = 0.5;
s = grid;
p1 = pistar;
A = -0.5*(1+a*b)^2;
B = (1+a*b)*(pistar+lambda/a-a*b*rstar)+a*b*u+l;
%C = -0.5*(pistar+lambda/a-a*b*rstar)^2+a*b*rstar*u-0.5*(u^2)-(pistar+lambda/a)*l;
C = -0.5*(-pistar-lambda/a+a*b*rstar)^2+a*b*rstar*u-0.5*(u^2)-(pistar+lambda/a)*l;

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu = rstar + ((1+a*b)*epi - pistar- lambda/a - s)/(a*b);
I  = [iu;zer];
i_shdms  = max(I);
inde = find(i_shdms);
[K,invind] = setdiff(obs,inde);
prob_nzlb_shdms = size(inde,2)/size(s,2);
pi_shdms(inde) = pistar + lambda/a;
pi_shdms(invind) = epi*(1+a*b)+a*b*rstar -s(invind);
epi_shdms = ones(1,size(d,2))*epi;

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make-up sim demand - symmetric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
T=250; 
P=10000;
pistar = 2;
rstar  = 0;
r1 = rstar;
lambda = 0.5;
prob_zlb_true = 0.3458;
prob_zlb = 0;
eps = 0;

while abs(prob_zlb-prob_zlb_true)>0.01
    u=1.1+eps;
    l=-u;
    eps = eps+0.0001; 
    
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A);

iu_check = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar)/(b*(lambda+a^2))+d./b;
I_check  = [iu_check;zer];
i_eff = max(I_check);
inde = find(i_eff);
prob_zlb = size(inde,2)/size(i_eff,2)
end

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)

pistart = zeros(T,P);
pistart(1,:) = pistar;
%dt      = u*(rand(T-1,P)-0.5);
dt = unifrnd(l,u,T-1,P);
iut     = zeros(T-1,P);
pit     = zeros(T-1,P);
avepi1   = zeros(T-1,P);
avepi2   = zeros(T-1,P);

for p = 1:P
for t = 1:T-1

    %dt(t) = l + (u-l)*(rand-0.5);
    iut(t,p) = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistart(t,p))/(b*(lambda+a^2))+dt(t,p);
    if iut(t,p)>0
        pit(t,p) = (lambda*epi+pistart(t)*a^2)/(lambda+a^2);
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar + a*dt(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = 2*pistar - pit(t,p);
    else
       pistart(t+1,p) = pistar;
    end
    avepi1(t,p) = mean(pit(1:t,p));
end
end

per1=10;
per2=90;

Per10a = prctile(avepi1,per1,2);
Per90a = prctile(avepi1,per2,2);

meanpi = mean(avepi1(T-1,:))

pistar = 2;
rstar  = 0.75;
r2 = rstar;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)
pistart = zeros(T,P);
pistart(1,:) = pistar;
iut     = zeros(T-1,P);
pit     = zeros(T-1,P);

for p = 1:P
for t = 1:T-1

    iut(t,p) = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistart(t,p))/(b*(lambda+a^2))+dt(t,p);
    if iut(t,p)>0
        pit(t,p) = (lambda*epi+pistart(t)*a^2)/(lambda+a^2);
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar + a*dt(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = 2*pistar - pit(t,p);
    else
       pistart(t+1,p) = pistar;
    end
    avepi2(t,p) = mean(pit(1:t,p));
end
end

Per10b = prctile(avepi2,10,2);
Per90b = prctile(avepi2,90,2);

meanpi = mean(avepi2(T-1,:))

figure7 = figure;
axes7 = axes('Parent',figure7);
h1 = plot(Per10a);
hold on
h2 = plot(Per90a);
hold on
h3 = plot(Per10b);
hold on
h4 = plot(Per90b);
hold off
xlabel('periods')
ylabel('%')
formatSpec = '$r^{\\ast} = $%0.0f $%d$th percentile';
formatSpec2 = '$r^{\\ast} = $%0.2f $%d$th percentile';
lstrh1 = sprintf(formatSpec,r1,per1);
set(h1,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh1,'LineWidth',2);
% set(lplot(2),'Color',[0.7,0,0],'LineStyle','--','DisplayName','r star - HLW original','LineWidth',2);
lstrh2 = sprintf(formatSpec,r1,per2);
set(h2,'Color',[0,0,1],'LineStyle','--','DisplayName',lstrh2,'LineWidth',2);
lstrh3 = sprintf(formatSpec2,r2,per1);
set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
lstrh4 = sprintf(formatSpec2,r2,per2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
legend7 = legend(axes7,'show');
set(legend7,'Location','best','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex Name
%fn = 'Figure_SimFAIT1_rev';
% Paper Name
fn = 'Figure6_a';
print( gcf, '-dpdf', fn )


%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make-up sim supply - symmetric
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pistar = 2;
rstar  = 0;
A = -0.5*(a*(1+a*b)+b*lambda)^2;
B = -(b*(lambda+a^2)*rstar - a*pistar)*(a*(1+a*b)+b*lambda)+a*b*(lambda+a^2)*u+l*a^2;
C = -0.5*(b*(a^2+lambda)*rstar-a*pistar)^2-pistar*l*a^2-0.5*(lambda+a^2)*u^2+a*b*(lambda+a^2)*u*rstar + 0.5*lambda*l^2;

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)

pistart = zeros(T,P);
pistart(1,:) = pistar;
%st      = u*(rand(T-1,P)-0.5);
st = unifrnd(l,u,T-1,P);
iut     = zeros(T-1,P);
pit     = zeros(T-1,P);
avepi1   = zeros(T-1,P);
avepi2   = zeros(T-1,P);
for p = 1:P
for t = 1:T-1

    iut(t,p) = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistart(t,p)-a*st(t,p))/(b*(lambda+a^2));
    if iut(t,p)>0
        pit(t,p) = (lambda*epi+pistart(t,p)*a^2-lambda*st(t,p))/(lambda+a^2);
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar -st(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = 2*pistar - pit(t,p);
    else
       pistart(t+1,p) = pistar;
    end
    avepi1(t,p) = mean(pit(1:t,p));
end
end
meanpi = mean(avepi1(T-1,:))

Per10a = prctile(avepi1,per1,2);
Per90a = prctile(avepi1,per2,2);


pistar = 2;
rstar  = 0.75;
A = -0.5*(a*(1+a*b)+b*lambda)^2;
B = -(b*(lambda+a^2)*rstar - a*pistar)*(a*(1+a*b)+b*lambda)+a*b*(lambda+a^2)*u+l*a^2;
C = -0.5*(b*(a^2+lambda)*rstar-a*pistar)^2-pistar*l*a^2-0.5*(lambda+a^2)*u^2+a*b*(lambda+a^2)*u*rstar + 0.5*lambda*l^2;

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)

for p = 1:P
for t = 1:T-1

    iut(t,p) = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistart(t,p)-a*st(t,p))/(b*(lambda+a^2));
    if iut(t,p)>0
        pit(t,p) = (lambda*epi+pistart(t,p)*a^2-lambda*st(t,p))/(lambda+a^2);
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar -st(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = 2*pistar - pit(t,p);
    else
       pistart(t+1,p) = pistar;
    end
    avepi2(t,p) = mean(pit(1:t,p));
end
end
meanpi = mean(avepi2(T-1))
Per10b = prctile(avepi2,10,2);
Per90b = prctile(avepi2,90,2);

figure8 = figure;
axes8 = axes('Parent',figure8);
h1 = plot(Per10a);
hold on
h2 = plot(Per90a);
hold on
h3 = plot(Per10b);
hold on
h4 = plot(Per90b);
hold off
xlabel('periods')
ylabel('%')
formatSpec = '$r^{\\ast} = $%0.0f $%d$th percentile';
formatSpec2 = '$r^{\\ast} = $%0.2f $%d$th percentile';
lstrh1 = sprintf(formatSpec,r1,per1);
set(h1,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh1,'LineWidth',2);
% set(lplot(2),'Color',[0.7,0,0],'LineStyle','--','DisplayName','r star - HLW original','LineWidth',2);
lstrh2 = sprintf(formatSpec,r1,per2);
set(h2,'Color',[0,0,1],'LineStyle','--','DisplayName',lstrh2,'LineWidth',2);
lstrh3 = sprintf(formatSpec2,r2,per1);
set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
lstrh4 = sprintf(formatSpec2,r2,per2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
legend8 = legend(axes8,'show');
set(legend8,'Location','best','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex Name
%fn = 'Figure_SimFAIT2_rev';
% Paper Name
fn = 'Figure6_b';
print( gcf, '-dpdf', fn )

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make-up sim demand - shortfalls
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pistar = 2;
rstar  = 0;
A = -0.5*(1+a*b)^2;
B = (1+a*b)*(pistar+lambda/a-a*b*rstar)-a*(u+a*b*l);
C = -0.5*(pistar+lambda/a-a*b*rstar)^2+(a*pistar+lambda)*u-(a^2)*b*rstar*l-0.5*(a^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)
pistart = zeros(T,P);
pistart(1,:) = pistar;
%dt      = u*(rand(T-1,P)-0.5);
dt = unifrnd(l,u,T-1,P);
iut     = zeros(T-1,P);
pit     = zeros(T-1,P);
avepi1   = zeros(T-1,P);
avepi2   = zeros(T-1,P);

for p = 1:P
for t = 1:T-1

    %dt(t) = l + (u-l)*(rand-0.5);
    iut(t,p) = rstar + ((1+a*b)*epi - pistart(t,p)- lambda/a + a*dt(t,p))/(a*b);
    if iut(t,p)>0
        pit(t,p) = pistar + lambda/a;
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar + a*dt(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = 2*pistar - pit(t,p);
    else
       pistart(t+1,p) = pistar;
    end
    avepi1(t,p) = mean(pit(1:t,p));
end
end
meanpi = mean(avepi1(T-1,:))
Per10a = prctile(avepi1,per1,2);
Per90a = prctile(avepi1,per2,2);


pistar = 2;
rstar  = 0.75;
r2 = rstar

A = -0.5*(1+a*b)^2;
B = (1+a*b)*(pistar+lambda/a-a*b*rstar)-a*(u+a*b*l);
C = -0.5*(pistar+lambda/a-a*b*rstar)^2+(a*pistar+lambda)*u-(a^2)*b*rstar*l-0.5*(a^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)

for p = 1:P
for t = 1:T-1

    %dt(t) = l + (u-l)*(rand-0.5);
    iut(t,p) = rstar + ((1+a*b)*epi - pistart(t,p)- lambda/a + a*dt(t,p))/(a*b);
    if iut(t,p)>0
        pit(t,p) = pistar + lambda/a;
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar + a*dt(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = 2*pistar - pit(t,p);
    else
       pistart(t+1,p) = pistar;
    end
    avepi2(t,p) = mean(pit(1:t,p));
end
end

Per10b = prctile(avepi2,10,2);
Per90b = prctile(avepi2,90,2);

meanpi = mean(avepi2(T-1,:))

figure9 = figure;
axes9 = axes('Parent',figure9);
h1 = plot(Per10a);
hold on
h2 = plot(Per90a);
hold on
h3 = plot(Per10b);
hold on
h4 = plot(Per90b);
hold off
xlabel('periods')
ylabel('%')
formatSpec = '$r^{\\ast} = $%0.0f $%d$th percentile';
formatSpec2 = '$r^{\\ast} = $%0.2f $%d$th percentile';
lstrh1 = sprintf(formatSpec,r1,per1);
set(h1,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh1,'LineWidth',2);
% set(lplot(2),'Color',[0.7,0,0],'LineStyle','--','DisplayName','r star - HLW original','LineWidth',2);
lstrh2 = sprintf(formatSpec,r1,per2);
set(h2,'Color',[0,0,1],'LineStyle','--','DisplayName',lstrh2,'LineWidth',2);
lstrh3 = sprintf(formatSpec2,r2,per1);
set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
lstrh4 = sprintf(formatSpec2,r2,per2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
legend9 = legend(axes9,'show');
set(legend9,'Location','best','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex Name 
%fn = 'Figure_SimFAIT3_rev';
% Paper Name
fn = 'Figure7_a';

print( gcf, '-dpdf', fn )

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make-up sim supply - shortfalls
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

pistar = 2;
rstar  = 0;

A = -0.5*(1+a*b)^2;
B = (1+a*b)*(pistar+lambda/a-a*b*rstar)+a*b*u+l;
C = -0.5*(pistar+lambda/a-a*b*rstar)^2+a*b*rstar*u-0.5*(u^2)-(pistar+lambda/a)*l;

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)


pistart = zeros(T,P);
pistart(1,:) = pistar;
%st      = u*(rand(T-1,P)-0.5);
st = unifrnd(l,u,T-1,P);
iut     = zeros(T-1,P);
pit     = zeros(T-1,P);
avepi1   = zeros(T-1,P);
avepi2   = zeros(T-1,P);

for p = 1:P
for t = 1:T-1

    iut(t,p) = rstar + ((1+a*b)*epi - pistart(t,p)- lambda/a - st(t,p))/(a*b);
    if iut(t,p)>0
        pit(t,p) = pistar + lambda/a;
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar -st(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = 2*pistar - pit(t,p);
    else
       pistart(t+1,p) = pistar;
    end
    avepi1(t,p) = mean(pit(1:t,p));
end
end
meanpi = mean(avepi1(T-1,:))

Per10a = prctile(avepi1,per1,2);
Per90a = prctile(avepi1,per2,2);


pistar = 2;
rstar  = 0.75;
A = -0.5*(1+a*b)^2;
B = (1+a*b)*(pistar+lambda/a-a*b*rstar)+a*b*u+l;
C = -0.5*(pistar+lambda/a-a*b*rstar)^2+a*b*rstar*u-0.5*(u^2)-(pistar+lambda/a)*l;

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)

for p = 1:P
for t = 1:T-1

    iut(t,p) = rstar + ((1+a*b)*epi - pistart(t,p)- lambda/a - st(t,p))/(a*b);
    if iut(t,p)>0
        pit(t,p) = pistar + lambda/a;
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar -st(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = 2*pistar - pit(t,p);
    else
       pistart(t+1,p) = pistar;
    end
    avepi2(t,p) = mean(pit(1:t,p));
end
end
meanpi = mean(avepi2(T-1,:))
Per10b = prctile(avepi2,10,2);
Per90b = prctile(avepi2,90,2);

figure10 = figure;
axes10 = axes('Parent',figure10);
h1 = plot(Per10a);
hold on
h2 = plot(Per90a);
hold on
h3 = plot(Per10b);
hold on
h4 = plot(Per90b);
hold off
xlabel('periods')
ylabel('%')
formatSpec = '$r^{\\ast} = $%0.0f $%d$th percentile';
formatSpec2 = '$r^{\\ast} = $%0.2f $%d$th percentile';
lstrh1 = sprintf(formatSpec,r1,per1);
set(h1,'Color',[0,0,1],'LineStyle',':','DisplayName',lstrh1,'LineWidth',2);
% set(lplot(2),'Color',[0.7,0,0],'LineStyle','--','DisplayName','r star - HLW original','LineWidth',2);
lstrh2 = sprintf(formatSpec,r1,per2);
set(h2,'Color',[0,0,1],'LineStyle','--','DisplayName',lstrh2,'LineWidth',2);
lstrh3 = sprintf(formatSpec2,r2,per1);
set(h3,'Color',[0.7,0,0]','DisplayName',lstrh3,'LineWidth',2);
lstrh4 = sprintf(formatSpec2,r2,per2);
set(h4,'Color',[0.7,0,0],'LineStyle',':','DisplayName',lstrh4,'LineWidth',2);
legend10 = legend(axes10,'show');
set(legend10,'Location','best','FontSize',18,'box','off','Interpreter','latex');
set(gcf,'PaperType','<custom>','PaperSize',[20.4 15.25],...
    'PaperPosition',[0.1 0.02158 20.3046 15.2284]);
% Latex Name
%fn = 'Figure_SimFAIT4_rev';
% Paper Name
fn = 'Figure7_b';

print( gcf, '-dpdf', fn )


%%
% Testing what x should be to reach the inflation target of 2% in presence
% of the disinflation bias

T=250; 
P=1000;
pistar = 2;
rstar  = 0;
r1 = rstar;
lambda = 0.5;
A = -0.5*(((a^2+lambda)*b+a))^2;
B = (lambda*b+a*(1+a*b))*(a*pistar-(a^2+lambda)*b*rstar)-a*(a^2+lambda)*u-b*l*(a^2+lambda)^2;
C = -0.5*(a*pistar-b*(a^2+lambda)*rstar)^2+a*pistar*u*(a^2+lambda)-b*rstar*l*((a^2+lambda)^2)-0.5*((a^2+lambda)^2)*(l^2);

epi = (-B-(B^2-4*A*C)^0.5)/(2*A)
pistart = zeros(T,P);
pistart(1,:) = pistar;
%dt      = u*(rand(T-1,P)-0.5);
dt = unifrnd(l,u,T-1,P);
iut     = zeros(T-1,P);
pit     = zeros(T-1,P);
avepi1   = zeros(T-1,P);
%avepi2   = zeros(T-1,P);

x = 1;
count = 0;
count_max = 5;
while abs(mean(mean(pit(1:T-1,:))) - 2) > 0.05 && (count < count_max)
iut     = zeros(T-1,P);
pit     = zeros(T-1,P);
avepi1   = zeros(T-1,P);
count = count + 1;
x = x + 0.1;
for p = 1:P
for t = 1:T-1

    %dt(t) = l + (u-l)*(rand-0.5);
    iut(t,p) = rstar + ((lambda*b+a*(1+a*b))*epi - a*pistar)/(b*(lambda+a^2))+dt(t,p);
    if iut(t,p)>0
        pit(t,p) = (lambda*epi+pistart(t)*a^2)/(lambda+a^2);
    else
        pit(t,p) = epi*(1+a*b)+a*b*rstar + a*dt(t,p);
        iut(t,p) = 0;
    end
    
    if pit(t,p)<pistar
       pistart(t+1,p) = pistar + x*(pistar - pit(t,p));
    else
       pistart(t+1,p) = pistar;
    end
    avepi1(t,p) = mean(pit(1:t,p));
end
end

per1=10;
per2=90;

Per10a = prctile(avepi1,per1,2);
Per90a = prctile(avepi1,per2,2);

meanpi = mean(avepi1(T-1))

end

